/* matrix.h */

/* VIS-5D version 3.0 */

/*
vis5d program for visualizing five dimensional gridded data sets
Copyright (C) 1990, 1991, 1992  Bill Hibbard, Brian Paul, Dave Santek,
and Andre Battaiola.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/



#ifndef MATRIX_H
#define MATRIX_H 1


/* Define the type Matrix. */

#if defined(sgi) || defined(ibm)
   /* If we're using IRIS GL, use its Matrix type. */
#  include "x.h"
#else
   /* foo: provide definition for Matrix. */
   typedef float Matrix[4][4];
#endif


extern void make_matrix();
/*
float  rotx, roty, rotz, scale, transx, transy, transz;
matrix  mat;
*/




/*** mat_mul *************************************************************
   Multiply two matrices.
   r = a * b
*************************************************************************/
extern void mat_mul();
/*
matrix  r, a, b;
*/


extern void mat_concat();




/*** mat_copy ***********************************************************
   Copy a matrix from src to dest.
************************************************************************/
extern void mat_copy();
/*
matrix dest, src;
*/



/*** mat_inv ***************************************************************
   Find the inverse of matrix 'mat' and return it in 'inv'.
***************************************************************************/
extern void mat_inv();
/*
matrix inv, mat;
*/



/*** vec_norm *********************************************************
   Normalize (scale) a vector, vin, to normal length (1.0).
   Return result in vout.
**********************************************************************/
extern void vec_norm();
/*
float vin[3],vout[3];
*/


/*** mat_vecmul **********************************************************
   Multiply a vector, v,  by a matrix, m.
*************************************************************************/
extern mat_vecmul();
/*
float v[3];
Matrix m;
*/


#endif
